Loading...
Searching...
No Matches
RDKit::Conformer Class Reference

The class for representing 2D or 3D conformation of a molecule. More...

`#include <Conformer.h>`

Inheritance diagram for RDKit::Conformer:

## Public Member Functions

| Conformer ()=default
| Constructor.
| Conformer (unsigned int numAtoms)
| Constructor with number of atoms specified ID specification.
| Conformer (const Conformer &other)=default
| Copy Constructor: initialize from a second conformation.
Conformer & | operator= (const Conformer &other)=default
| Conformer (Conformer &&o) noexcept
Conformer & | operator= (Conformer &&o) noexcept
| ~Conformer ()=default
| Destructor.
void | resize (unsigned int size)
void | reserve (unsigned int size)
| Reserve more space for atom position.
bool | hasOwningMol () const
| returns whether or not this instance belongs to a molecule
ROMol & | getOwningMol () const
| Get the molecule that owns this instance.
const RDGeom::POINT3D_VECT & | getPositions () const
| Get a const reference to the vector of atom positions.
RDGeom::POINT3D_VECT & | getPositions ()
| Get a reference to the atom positions.
const RDGeom::Point3D & | getAtomPos (unsigned int atomId) const
| Get the position of the specified atom.
template<class U>
const RDGeom::Point3D & | getAtomPos (U atomId) const
| overload
RDGeom::Point3D & | getAtomPos (unsigned int atomId)
| Get the position of the specified atom.
template<class U>
RDGeom::Point3D & | getAtomPos (U atomId)
| overload
void | setAtomPos (unsigned int atomId, const RDGeom::Point3D &position)
| Set the position of the specified atom.
template<class U>
void | setAtomPos (U atomId, const RDGeom::Point3D &position)
| overload
unsigned int | getId () const
| get the ID of this conformer
void | setId (unsigned int id)
| set the ID of this conformer
unsigned int | getNumAtoms () const
| Get the number of atoms.
bool | is3D () const
void | set3D (bool v)
Public Member Functions inherited from RDKit::RDProps
| RDProps ()
| RDProps (const RDProps &rhs)
RDProps & | operator= (const RDProps &rhs)
| RDProps (RDProps &&o) noexcept=default
RDProps & | operator= (RDProps &&rhs) noexcept=default
void | clear ()
const Dict & | getDict () const
| gets the underlying Dictionary
Dict & | getDict ()
STR_VECT | getPropList (bool includePrivate=true, bool includeComputed=true) const
| returns a list with the names of our `properties`
template<typename T>
void | setProp (const std::string_view key, T val, bool computed=false) const
| sets a `property` value
template<typename T>
void | getProp (const std::string_view key, T &res) const
| allows retrieval of a particular property value
template<typename T>
T | getProp (const std::string_view key) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<typename T>
bool | getPropIfPresent (const std::string_view key, T &res) const
bool | hasProp (const std::string_view key) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | clearProp (const std::string_view key) const
| clears the value of a `property`
void | clearComputedProps () const
| clears all of our `computed` `properties`
void | updateProps (const RDProps &source, bool preserveExisting=false)
| update the properties from another

## Protected Member Functions

void | setOwningMol (ROMol *mol)
| Set owning molecule.
void | setOwningMol (ROMol &mol)
| Set owning molecule.

## Friends

class | ROMol

## Additional Inherited Members

Protected Attributes inherited from RDKit::RDProps
Dict | d_props

## Detailed Description

The class for representing 2D or 3D conformation of a molecule.

This class contains

- a pointer to the owing molecule
- a vector of 3D points (positions of atoms)

Definition at line 46 of file Conformer.h.

## Constructor & Destructor Documentation

## Conformer() [1/4]

RDKit::Conformer::Conformer | ( |  | ) |

default

Constructor.

Referenced by Conformer(), Conformer(), operator=(), and operator=().

## Conformer() [2/4]

RDKit::Conformer::Conformer | ( | unsigned int | numAtoms | ) |

inline

Constructor with number of atoms specified ID specification.

Definition at line 54 of file Conformer.h.

## Conformer() [3/4]

RDKit::Conformer::Conformer | ( | const Conformer & | other | ) |

default

Copy Constructor: initialize from a second conformation.

References Conformer().

## Conformer() [4/4]

RDKit::Conformer::Conformer | ( | Conformer && | o | ) |

inline noexcept

Definition at line 60 of file Conformer.h.

References Conformer(), and RDKit::RDProps::RDProps().

## ~Conformer()

RDKit::Conformer::~Conformer | ( |  | ) |

default

Destructor.

## Member Function Documentation

## getAtomPos() [1/4]

template<class U>

RDGeom::Point3D & RDKit::Conformer::getAtomPos | ( | U | atomId | ) |

inline

overload

Definition at line 114 of file Conformer.h.

References getAtomPos(), and rdcast.

## getAtomPos() [2/4]

template<class U>

const RDGeom::Point3D & RDKit::Conformer::getAtomPos | ( | U | atomId | ) | const

inline

overload

Definition at line 106 of file Conformer.h.

References getAtomPos(), and rdcast.

## getAtomPos() [3/4]

RDGeom::Point3D & RDKit::Conformer::getAtomPos | ( | unsigned int | atomId | ) |

Get the position of the specified atom.

## getAtomPos() [4/4]

const RDGeom::Point3D & RDKit::Conformer::getAtomPos | ( | unsigned int | atomId | ) | const

Get the position of the specified atom.

Referenced by getAtomPos(), and getAtomPos().

## getId()

unsigned int RDKit::Conformer::getId | ( |  | ) | const

inline

get the ID of this conformer

Definition at line 134 of file Conformer.h.

## getNumAtoms()

unsigned int RDKit::Conformer::getNumAtoms | ( |  | ) | const

inline

Get the number of atoms.

Definition at line 140 of file Conformer.h.

References rdcast.

## getOwningMol()

ROMol & RDKit::Conformer::getOwningMol | ( |  | ) | const

inline

Get the molecule that owns this instance.

Definition at line 91 of file Conformer.h.

References PRECONDITION, and ROMol.

## getPositions() [1/2]

RDGeom::POINT3D_VECT & RDKit::Conformer::getPositions | ( |  | ) |

Get a reference to the atom positions.

## getPositions() [2/2]

const RDGeom::POINT3D_VECT & RDKit::Conformer::getPositions | ( |  | ) | const

Get a const reference to the vector of atom positions.

Referenced by RDKit::hasNonZeroZCoords().

## hasOwningMol()

bool RDKit::Conformer::hasOwningMol | ( |  | ) | const

inline

returns whether or not this instance belongs to a molecule

Definition at line 88 of file Conformer.h.

## is3D()

bool RDKit::Conformer::is3D | ( |  | ) | const

inline

Definition at line 143 of file Conformer.h.

## operator=() [1/2]

Conformer & RDKit::Conformer::operator= | ( | Conformer && | o | ) |

inline noexcept

Definition at line 66 of file Conformer.h.

References Conformer(), and RDKit::RDProps::operator=().

## operator=() [2/2]

Conformer & RDKit::Conformer::operator= | ( | const Conformer & | other | ) |

default

References Conformer().

## reserve()

void RDKit::Conformer::reserve | ( | unsigned int | size | ) |

inline

Reserve more space for atom position.

Definition at line 85 of file Conformer.h.

## resize()

void RDKit::Conformer::resize | ( | unsigned int | size | ) |

inline

Resize the conformer so that more atoms location can be added. Useful, for e.g., when adding hydrogens

Definition at line 82 of file Conformer.h.

## set3D()

void RDKit::Conformer::set3D | ( | bool | v | ) |

inline

Definition at line 144 of file Conformer.h.

## setAtomPos() [1/2]

template<class U>

void RDKit::Conformer::setAtomPos | ( | U | atomId,
|  | const RDGeom::Point3D & | position )

inline

overload

Definition at line 130 of file Conformer.h.

References rdcast, and setAtomPos().

## setAtomPos() [2/2]

void RDKit::Conformer::setAtomPos | ( | unsigned int | atomId,
|  | const RDGeom::Point3D & | position )

inline

Set the position of the specified atom.

Definition at line 119 of file Conformer.h.

Referenced by setAtomPos().

## setId()

void RDKit::Conformer::setId | ( | unsigned int | id | ) |

inline

set the ID of this conformer

Definition at line 137 of file Conformer.h.

## setOwningMol() [1/2]

void RDKit::Conformer::setOwningMol | ( | ROMol & | mol | ) |

protected

Set owning molecule.

References ROMol.

## setOwningMol() [2/2]

void RDKit::Conformer::setOwningMol | ( | ROMol * | mol | ) |

protected

Set owning molecule.

References ROMol.

## Friends And Related Symbol Documentation

## ROMol

friend class ROMol

friend

Definition at line 48 of file Conformer.h.

References ROMol.

Referenced by getOwningMol(), ROMol, setOwningMol(), and setOwningMol().

The documentation for this class was generated from the following file:

- Conformer.h